﻿using System;
using System.Text;
using System.Windows.Forms;

using System.Text.RegularExpressions;
using System.Reflection;

namespace Xenon.RubyTagger
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void txtInput_MouseMove(object sender, MouseEventArgs e)
        {
            //------------------------------------------------------------
            // 文字列変換プレビュー
            //------------------------------------------------------------

            // 「書（か）」といった文字を選択した場合、
            // 「<ruby>書<rt>か</rt></ruby>」というプレビューを表示します。


            //正規表現パターンとオプションを指定してRegexオブジェクトを作成
            Regex r = new Regex( @"(.*)[(|（](.*)[)|）]", RegexOptions.None );

            //TextBox1.Text内で正規表現と一致する対象をすべて検索
            MatchCollection mc = r.Matches(this.txtInput.SelectedText);


            foreach (Match m in mc)
            {
                //正規表現に一致したグループと位置を表示
                Console.WriteLine( "【" + m.Groups[1].Value + "】【" + m.Groups[2].Value + "】【" + m.Groups[1].Index + "】");


                // 変換後の文字
                this.txtPreview.Text = "<ruby>" + m.Groups[1].Value + "<rt>" + m.Groups[2].Value + "</rt></ruby>";


                break;
            }
        }

        private void txtInput_KeyDown(object sender, KeyEventArgs e)
        {
            if (Keys.F5 == e.KeyCode)
            {
                //------------------------------------------------------------
                // [F5]キー
                //------------------------------------------------------------

                // 変換を実行します
                StringBuilder sb = new StringBuilder();

                sb.Append(this.txtInput.Text.Substring(0, this.txtInput.SelectionStart) );
                sb.Append(this.txtPreview.Text);
                sb.Append(this.txtInput.Text.Substring(this.txtInput.SelectionStart + this.txtInput.SelectionLength, this.txtInput.Text.Length - (this.txtInput.SelectionStart + this.txtInput.SelectionLength)));

                this.txtInput.Text = sb.ToString();
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //------------------------------------------------------------
            // バージョン
            //------------------------------------------------------------
            Assembly assembly = Assembly.GetExecutingAssembly();
            Version version = assembly.GetName().Version;

            this.Text += "　" + version.Major + "." + version.Minor.ToString("00");
        }
    }
}
